unit -->GrammarTestHarness_Main;

(* NOTE: Any changes made to this file may be overwritten when it gets regenerated
  from within ParserBuilder *)


interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, JvDragDrop,-->GrammarParser;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Memo1: TMemo;
    Splitter1: TSplitter;
    Memo2: TMemo;
    BitBtn1: TBitBtn;
    JvDragDrop1: TJvDragDrop;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure JvDragDrop1Drop(Sender: TObject; Pos: TPoint;
      Value: TStringList);
  private
    { Private declarations }
    F-->GrammarParser : T-->GrammarParser;
    Procedure DoParse;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.DoParse;
begin
  F-->GrammarParser.SourceString := Memo1.Lines.Text;
  F-->GrammarParser.Parse;
  Memo2.Lines.Text := F-->GrammarParser.lst.DataString;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  F-->GrammarParser := T-->GrammarParser.Create;
  Caption := '-->Grammar Parser Test Harness';
  if FileExists('sample.txt') then
  Memo1.Lines.LoadFromFile('sample.txt');
  Memo2.Lines.Add('Drag a file into the top memo to load it.');
  Memo2.Lines.Add('Drag file(s) into the bottom memo to parse in bulk.');
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Memo1.Lines.SaveToFile('sample.txt');
  F-->GrammarParser.Free;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  DoParse;
end;

procedure TForm1.JvDragDrop1Drop(Sender: TObject; Pos: TPoint;
  Value: TStringList);
Var idx : Integer;
   CtrlHandle : THandle;
   SL : TStringList;
begin
  CtrlHandle := ChildWindowFromPoint(Handle,Pos);
  if (Memo1.Handle = ctrlHandle) then
    Begin
      Memo1.Lines.LoadFromFile(Value[0]);
      Memo2.Clear;
    end
  else
  Begin
  SL := TStringList.Create;
  for idx := 0 to Value.Count-1 do
  Begin
    SL.LoadFromFile(Value[idx]);
    F-->GrammarParser.SourceString := SL.Text;
    F-->GrammarParser.Parse;
    Memo2.Lines.Add('FILE: '+  Value[idx]+#13#10+'OUTPUT:'+#13#10+
    F-->GrammarParser.lst.DataString+#13#10+'........................................................'+#13#10);
  End;
  SL.Free;
  end;
end;


end.  -->End.
